#!/bin/bash

########################################################################################################################
# DEFAULTS
########################################################################################################################

    QUIET_MODE="false"


########################################################################################################################
# FUNCTIONS
########################################################################################################################

    # Generate a pseudo UUID
    function Make_UUID()
    {
        local N B C='89ab'

        for (( N=0; N < 16; ++N ))
        do
            B=$(( $RANDOM%256 ))

            case $N in
                6)
                    printf '4%x' $(( B%16 ))
                    ;;
                8)
                    printf '%c%x' ${C:$RANDOM%${#C}:1} $(( B%16 ))
                    ;;
                3 | 5 | 7 | 9)
                    printf '%02x-' $B
                    ;;
                *)
                    printf '%02x' $B
                    ;;
            esac
        done

        echo
}


########################################################################################################################
# INPUT
########################################################################################################################

    for input in "${@}"
        do
            case "${input}" in

                --quiet | -q)
                    QUIET_MODE="true"
                    shift 1
                    ;;
            esac
    done


########################################################################################################################
# EXECUTION
########################################################################################################################

    [ "${QUIET_MODE}" = "false" ] && printf "\n---> Pseudo UUID Generator <---\n\n"

    if [ "$BASH_SOURCE" == "$0" ]
        then
            Make_UUID
    fi

    [ "${QUIET_MODE}" = "false" ] && printf "\n"
